﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace AudioMate
{
    public class OverlayCallbackButton
    {
        public string Label = "";
        public int Style = Styles.ButtonOutlines;
        public Action Callback;
    }

    public class OverlayArgButton
    {
        public string Label = "";
        public int Style = Styles.Button;
        public string StringValue = "";
    }

    public class OverlaySettings
    {
        public OverlaySettings(List<OverlayCallbackButton> mainButtons, List<OverlayArgButton> argButtons)
        {
            MainButtons = mainButtons;
            ArgButtons = argButtons;
        }
        public readonly List<OverlayCallbackButton> MainButtons;
        public List<OverlayArgButton> ArgButtons;
        public Action Callback
        {
            get { return MainButtons?.FirstOrDefault()?.Callback; }
            set { if (MainButtons[0] != null) MainButtons[0].Callback = value; }
        }
    }

    public static class OverlayTemplates
    {
        public static OverlaySettings ConfirmCancel = new OverlaySettings
        (
            new List<OverlayCallbackButton>()
            {
                new OverlayCallbackButton()
                {
                    Label = "Confirm",
                    Style = Styles.ButtonOutlines,
                    Callback = () => {}
                },
                new OverlayCallbackButton()
                {
                    Label = "Cancel",
                    Style = Styles.ButtonOutlines,
                    Callback = () => {}
                }
            },
            null
        );

        public static readonly OverlaySettings YesNo = new OverlaySettings
        (
            new List<OverlayCallbackButton>()
            {
                new OverlayCallbackButton()
                {
                    Label = "Yes",
                    Style = Styles.ButtonOutlines,
                    Callback = () => {}
                },
                new OverlayCallbackButton()
                {
                    Label = "No",
                    Style = Styles.ButtonOutlines,
                    Callback = () => {}
                }
            }, null
        );

        public static readonly OverlaySettings Ok = new OverlaySettings
        (
            new List<OverlayCallbackButton>()
            {
                new OverlayCallbackButton()
                {
                    Label = "Ok",
                    Style = Styles.ButtonOutlines,
                    Callback = () => {}
                }
            }, null
        );
    }
}
