﻿using UnityEngine;

namespace AudioMate
{
    public static class Styles
    {
        public const int Standard = 0;
        public const int Button = 1;
        public const int Enabled = 2;
        public const int Disabled = 3;
        public const int Success = 4;
        public const int Danger = 5;
        public const int Input = 6;
        public const int Embedded = 7;
        public const int Tab = 8;
        public const int TabActive = 9;
        public const int Overlay = 10;
        public const int ButtonSelected = 11;
        public const int Popup = 12;
        public const int Slider = 13;
        public const int Toggle = 14;
        public const int ButtonOutlines = 15;



        public static readonly Color StandardText = Palette.Text;
        public static readonly Color StandardBg = Palette.Background;
        public static readonly Color ButtonText = Palette.Text;
        public static readonly Color ButtonBg = Palette.ButtonBackground;
        public static readonly Color ButtonOutlinesText = Palette.TextAlt;
        public static readonly Color ButtonOutlinesBg = Color.clear;
        public static readonly Color ButtonSelectedText = Palette.TextAlt;
        public static readonly Color ButtonSelectedBg = Palette.Gray;
        public static readonly Color PopupText = Palette.EmbeddedText;
        public static readonly Color PopupBg = Palette.EmbeddedBackground;
        public static readonly Color SliderText = Palette.EmbeddedText;
        public static readonly Color SliderBg = Palette.EmbeddedBackground;
        public static readonly Color ToggleText = Palette.EmbeddedText;
        public static readonly Color ToggleBg = Palette.EmbeddedBackground;
        public static readonly Color SuccessText = Palette.TextAlt;
        public static readonly Color SuccessBg = Palette.Success;
        public static readonly Color DangerText = Palette.TextAlt;
        public static readonly Color DangerBg = Palette.Danger;
        public static readonly Color EnabledText = Palette.TextAlt;
        public static readonly Color EnabledBg = Palette.Gray;
        public static readonly Color DisabledText = Palette.LightGray;
        public static readonly Color DisabledBg = Palette.DarkGray;
        public static readonly Color InputText = Palette.TextAlt;
        public static readonly Color InputBg = Palette.Gray;
        public static readonly Color EmbeddedText = Palette.TextAlt;
        public static readonly Color EmbeddedBg = Palette.TransparentLightGray;
        public static readonly Color TabText = Palette.Text;
        public static readonly Color TabBg = Palette.TransparentLightWhite;
        public static readonly Color TabActiveText = Palette.TextAlt;
        public static readonly Color TabActiveBg = Palette.BackgroundAlt;
        public static readonly Color CursorEnabledText = SuccessBg;
        public static readonly Color CursorEnabledBg = SuccessText;
        public static readonly Color CursorDisabledText = SuccessText;
        public static readonly Color CursorDisabledBg = SuccessBg;
        public static readonly Color OverlayBg = Palette.TransparentLightWhite;
        public static readonly Color ModalText = Palette.TextAlt;
        public static readonly Color ModalBg = Palette.Background;


        public static Color Text(int category = -1)
        {
            switch (category)
            {
                case Button:
                    return ButtonText;
                case ButtonSelected:
                    return ButtonSelectedText;
                case ButtonOutlines:
                    return ButtonOutlinesText;
                case Toggle:
                    return ToggleText;
                case Enabled:
                    return EnabledText;
                case Disabled:
                    return DisabledText;
                case Success:
                    return SuccessText;
                case Danger:
                    return DangerText;
                case Input:
                    return InputText;
                case Embedded:
                    return EmbeddedText;
                case Tab:
                    return TabText;
                case TabActive:
                    return TabActiveText;
                case Overlay:
                    return ModalText;
            }

            return StandardText;
        }

        public static Color Bg(int category = -1)
        {
            switch (category)
            {
                case Button:
                    return ButtonBg;
                case ButtonSelected:
                    return ButtonSelectedBg;
                case ButtonOutlines:
                    return ButtonOutlinesBg;
                case Toggle:
                    return ToggleBg;
                case Enabled:
                    return EnabledBg;
                case Disabled:
                    return DisabledBg;
                case Success:
                    return SuccessBg;
                case Danger:
                    return DangerBg;
                case Input:
                    return InputBg;
                case Embedded:
                    return EmbeddedBg;
                case Tab:
                    return TabBg;
                case TabActive:
                    return TabActiveBg;
                case Overlay:
                    return OverlayBg;
            }

            return StandardBg;
        }
    }
}
