using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;

namespace AudioMate
{
    public class VerticalGroup : HorizontalButtonGroup
    {
        protected new VerticalLayoutGroup Layout;

        public override void Init()
        {
            Container = new GameObject($"VerticalGroup{Tools.GenerateID()}");
            Container.transform.SetParent(transform, false);
            Layout = Container.AddComponent<VerticalLayoutGroup>();
            Layout.spacing = 10f;
            Layout.childForceExpandWidth = false;
            Layout.childForceExpandHeight = false;
            Layout.childControlWidth = true;
            Layout.childControlHeight = true;
            Layout.childAlignment = TextAnchor.MiddleCenter;
        }
    }
}
